from datetime import datetime
import unittest

from pyson.ObjectMapper import ObjectMapper
from uri import URI

from geniusweb.actions.PartyId import PartyId
from geniusweb.inform.Agreements import Agreements
from geniusweb.inform.Inform import Inform
from geniusweb.inform.Settings import Settings
from geniusweb.issuevalue.Bid import Bid
from geniusweb.progress.ProgressTime import ProgressTime
from geniusweb.references.Parameters import Parameters
from geniusweb.references.ProfileRef import ProfileRef
from geniusweb.references.ProtocolRef import ProtocolRef


class SettingsTest(unittest.TestCase):
    id1 = PartyId("party1")
    id2 = PartyId("party2")
    profileref1 = ProfileRef(URI("profile1"))
    protocolref1 = ProtocolRef(URI("protoco1"))
    progress1=ProgressTime(1000, datetime.fromtimestamp(12345))
    parameters1=Parameters()

    settings1  = Settings(id1, profileref1, protocolref1, progress1, parameters1 )
    settings2  = Settings(id2, profileref1, protocolref1, progress1, parameters1 )
    
    settings1json={'Settings': {'id': 'party1', 'profile': 'profile1', 'protocol': 'protoco1', 'progress': {'ProgressTime': {'duration': 1000, 'start': 12345000}}, 'parameters': {'params': {}}}}


    

    def testSerialize(self):
        pyson=ObjectMapper()
        print(str(pyson.toJson(self.settings1)))
        self.assertEqual(self.settings1json, pyson.toJson(self.settings1))
        
    def testDeserialize(self):
        pyson=ObjectMapper()
        self.assertEqual(self.settings1, pyson.parse(self.settings1json, Inform))
        